/****************************************************************************
 *
 * Copyright (c) 2011
 *     Kevin Zhang
 *     All rights reserved.
 *
 * This file is the confidential and proprietary property of 
 * Kevin Zhang and the possession or use of this file requires 
 * a written license from the author.
 * Filename: 
 * Abstract:
 *          JZSearchAPI.h: definition of the JZSearch API
 * Author:   Kevin Zhang 
 *          (pipy_zhang@msn.com) www.nlpir.org
 * Date:     2011-8-20
 *
 * Notes:
 *                
 ****************************************************************************/
#if !defined(__JZSEARCH_2010_LIB_INCLUDED__)
#define __JZSEARCH_2010_LIB_INCLUDED__

#ifdef _WIN32
#ifdef JZSEARCHAPI_EXPORTS
#define JZSearchAPI_API __declspec(dllexport)
#else
#define JZSearchAPI_API __declspec(dllimport)
#endif
#else
#define JZSearchAPI_API
#endif
#include <stdio.h>
#include <vector>
//////////////////////////////////////////////////////////////////////////
//
//	²ΪֶζAPI
//
//////////////////////////////////////////////////////////////////////////

#define FIELD_TYPE_TEXT 1
#define FIELD_TYPE_INT 2
#define FIELD_TYPE_LONG 3
#define FIELD_TYPE_DATETIME 4
#define FIELD_TYPE_FLOAT 5
#define DATA_TYPE_BIGTEXT 6
#define FIELD_TYPE_NAME 8
JZSearchAPI_API bool JZIndexer_FieldAdd(const char *sFieldName,const char *sDBFieldName,int nFieldType,bool bIndexed,bool bRetrieved,bool bGeneral=false,bool bAbstracted=false);
//ֶ			ǷҪ	ǷҪ	ǷҪ洢	ǷΪͨ	
//sFieldName:ƣУΨһʾ
//sDBFieldNameӦݿֶƣݿʱڻȡݿ
//nFieldType:
	//FIELD_TYPE_TEXT
	//FIELD_TYPE_INT
	//FIELD_TYPE_LONG
	//FIELD_TYPE_DATETIME
//bIndexed:ǷҪ
//bRetrieved:ǷҪֶ
//bGeneral:Ƿͨķ
//bAbstract:ǷժҪȡ


JZSearchAPI_API bool JZIndexer_FieldSave(const char *sFieldInfoDataFile);
//Ϣļ
JZSearchAPI_API bool JZIndexer_FieldLoad(const char *sFieldInfoDataFile);
//ȡѾõϢļ




//////////////////////////////////////////////////////////////////////////
//
//	²ΪAPI
//
//////////////////////////////////////////////////////////////////////////
#define INDEX_ENCODING_GBK 0
#define INDEX_ENCODING_UTF8 INDEX_ENCODING_GBK+1
#define INDEX_ENCODING_BIG5 INDEX_ENCODING_GBK+2
#define INDEX_ENCODING_GBK_FANTI INDEX_ENCODING_GBK+3//GBKа֣ͳһݣƼʹINDEX_ENCODING_GBK_FANTI
#define INDEX_ENCODING_COUNT 4

#define LANGUAGE_TYPE_UNKNOWN 0
#define LANGUAGE_TYPE_CHINESE 1
#define LANGUAGE_TYPE_UYGHAN 2


JZSearchAPI_API bool JZIndexer_Init(const char *sDictPath=0,const char *sFieldInfoFile=0,int encoding=INDEX_ENCODING_GBK_FANTI,bool bICTCLAS=false,int lang_type=LANGUAGE_TYPE_CHINESE,const char*sLicenceCode=NULL);
//ϵͳʼʼ󣬲ʹCJZIndexer
//sDictPathʵļΪʱn-gram
//sFieldInfoFile:ֶϢֶ֧Ϊֻ֧һֶ

JZSearchAPI_API bool JZIndexer_Exit();
//ϵͳ˳

//
class JZSearchAPI_API CJZIndexer {
public:
	//ڴС
	CJZIndexer(const char *pcIndexFile,int nMaxMemSize=512000000 );

	~CJZIndexer(void);
	// TODO: add your methods here.
	int MemIndexing(const char *pText,const char *sFieldName=0,int nMemSize=0);
	//һڴ棬
	//sFieldNameֶƣΪʾֶϢ

	int FileIndexing(const char *sTextFilename,const char *sFieldName=0);
	//һıļ
	//sFieldNameֶƣΪʾֶϢ

	int BigFileIndexing(const char *sBigFilename,unsigned int nOffset,unsigned int nSize,const char *sFieldName=0);
	//һBig Fileָƫͳȵıļ
	//sBigFilename: Big Fileļ
	//nOffset:ƫ
	//nSize: ļ
	//sFieldNameֶƣΪʾֶϢ

	int IdIndexing(int term_id,const char *sFieldName=0);
	//ID,
	//sFieldNameֶƣΪʾֶϢ

	int IntIndexing(int value,const char *sFieldName=0);
	//ֵ,
	//sFieldNameֶƣΪʾֶϢ
#ifndef _WIN32
	int LongIndexing(long long value,const char *sFieldName=0);
	//64λֵ,
	//sFieldNameֶƣΪʾֶϢ
#else
	int LongIndexing(__int64 value,const char *sFieldName=0);
	//64λֵ,
	//sFieldNameֶƣΪʾֶϢ
#endif
	int FloatIndexing(float value,const char *sFieldName=0);
	//ֵ,

	//sFieldNameֶƣΪʾֶϢ
	bool Save();
	//
	
	//
	int Merge();
	//ϲ
	
	int AddDoc();//ĵ
	int GetStatus();//ȡϵͳ״̬1ʾCIndexerɹ
private://²ΪϵͳʹãӦÿ߲Ҫдֻܶȡ
	int m_nHandle;//Handle
	int m_nStatus;
	char m_sBigfilename[1000];//big filename,added in 2011/12/4
	FILE *m_fpBigFile;//Big File pointer,added in 2011/12/4
};


//////////////////////////////////////////////////////////////////////////
//
//	²ΪAPI
//
//////////////////////////////////////////////////////////////////////////

#define SORT_TYPE_DOCID 1//Doc IDĬϷʽ
#define SORT_TYPE_RELEVANCE 2//ض
#define SORT_TYPE_DOCID_REVERSE 3//Doc IDĬϷʽ
#define  SEARCHER_HANDLE int

JZSearchAPI_API SEARCHER_HANDLE JZSearch_Init(const char *sIndexFile,const char *sDictPath=0,const char *sFieldInfoFile=0,int MaxMemSize=512000000,int encoding=INDEX_ENCODING_GBK_FANTI,int nGroupMaxCount=0,bool bICTCLAS=false,int lang_type=LANGUAGE_TYPE_CHINESE,const char*sLicenceCode=NULL);
//ϵͳʼʼ󣬲ʹCJZSearcher
//sDictPathʵļΪʱn-gram
//sIndexFileļ

JZSearchAPI_API bool JZSearch_Exit(SEARCHER_HANDLE handle=0);
//handleϵͳ˳(handle==0)Ҫ˳ڴ濪

JZSearchAPI_API bool JZSearch_Reload(SEARCHER_HANDLE handle=0);
//ϵͳº¼

JZSearchAPI_API const char * JZSearch_ReloadBlackList(void);
//ôʺº¼

JZSearchAPI_API const char * JZSearch_ReloadQueryExpand(void);
//չʸº¼

JZSearchAPI_API int JZSearch_ListFieldAllValue(const char *sFieldLine,const char *sExportFile,bool bDuplicateErase=false,SEARCHER_HANDLE handle=1);
//гֶָ

JZSearchAPI_API bool JZSearch_Export(const char *sExportFile,const char *sWordList,char arg,SEARCHER_HANDLE handle=0);
//ڲݣԱ˲

JZSearchAPI_API bool JZSearch_Export(int nTermID,const char *sExportFile,const char *sWordList,SEARCHER_HANDLE handle=0);
//ڲݣԱ˲

JZSearchAPI_API bool JZSearch_Merge(SEARCHER_HANDLE handle=0);
//ϵͳԶŻϢй鲢

JZSearchAPI_API bool JZSearch_Backup(const char *sFilename=0,SEARCHER_HANDLE handle=0);
//ϵͳԶݣһ㲻ûʹãϵͳԶ

JZSearchAPI_API bool JZSearch_Restore(SEARCHER_HANDLE handle=0);
//ϵͳԶظһ㲻ûʹãϵͳ޷صǰʱԶָ

typedef struct tRESULT_RECORD {//ṹڼʹ
	int doc_id;
	int offset;//ֶڵƫ
	double score;//õĴֻ
}RESULT_RECORD;
typedef RESULT_RECORD * RESULT_RECORD_VECTOR;
class JZSearchAPI_API  CJZSearcher{
public:
	CJZSearcher(int sort_type=SORT_TYPE_DOCID,SEARCHER_HANDLE handle=1);
	~CJZSearcher(void);
	// TODO: add your methods here.
	
	void Search(const char *query_line,int nStart,int nPageCount,const char *sResultName=0);
	//query_line: ѯʽ
	//nStart:¼ʼַ
	//nPageCountǰҳؽĿ
	//nPageCount=-1:ǰҳҪеĽĿ
	//sResultName洢XMLַ

	const RESULT_RECORD_VECTOR Search(const char *query_line,int *p_nResultCountRet,bool bNoSort=false);
	//query_line: ѯʽ
	//p_nResultCountRet:
	//bool bNoSort:
	
	int Search(const char *query_line,std::vector<int> &vecDocID);
	//query_line: ѯʽ
	//vecDocIDDocID
	//Return the result count
	//added in 2013/8/15

	//Get field value according to docID and fieldName
	const char * GetFiledValue(int nDocID, const char * sFiledName);
	////nDocID:Ҫȡļţ0ʼ
	////sFiledName:Ҫȡ	
	//added in 2013/8/15

	const char *GetResultBuf(const char *pcQuery, int nQuerySize, int &nBufSize);
	//Search(const char *query_line,int nStart,int nPageCount,const char *sResultName=0)ʹãȡ
	//ṩDBTSearchʹãDBTSearchͻ˱̽ӿڽ;Ӧÿ

	const RESULT_RECORD_VECTOR  GetForeignKeyValues(const char *sFieldName, int *nResultCountRet);
	//Search(const char *query_line,int nStart,int nPageCount,const char *sResultName=0)ʹãȡ
	//ָݵֵб

	int FilterWithForeignKeyValues(const char *sFieldName, RESULT_RECORD_VECTOR pVecValues,int nResultCount,const char *sQueryLine);
	//

	bool DocDelete(int doc_id);

private://²ΪϵͳʹãӦÿ߲Ҫдֻܶȡ
	int m_nSearcherHandle;//Searcher handle;added in 2012/9/10
	int m_nHandle;
	int m_nSortType;//򷽷

	char *m_pResultBuf;
	int m_nResultMaxSize;//󳤶
};
#endif
